#ifndef __ITERATOR__
#define __ITERATOR__
#include "shape.h"

typedef struct {
  int nn;
  int *dd;
  int *ss;
  int numelem;
  int *index;
  int *ostep, *istep, *jstep;
} Iterator;

void iterator_free(Iterator tt);

Shape iterator_shape(Iterator tt);
Index iterator_index(Iterator tt);

Iterator iterator_1arg(Shape oo, Shape ii);
Iterator iterator_2arg(Shape oo, Shape ii, Shape jj);
Iterator iterator_permute(Shape ii, int *dim, int *perm);

#endif
