#ifndef  __SHAPE_OP_NUM2ARG__
#define  __SHAPE_OP_NUM2ARG__
#include "shape.h"

/* assumes existence of elemop_name */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray*prhs[])
{
  Shape ii, jj;
  if ( nrhs != 2 )
    mexErrMsgTxt("Exactly two arguments expected.");
  ii = shape_readmxarray(prhs[0]);
  jj = shape_readmxarray(prhs[1]);
  plhs[0] = mxCreateScalarDouble((double) elemop_name(ii,jj));
  shape_free(ii);
  shape_free(jj);
}

#endif
